Bug 1781186 - Progress percentage not working as expected with foreman-installer
Summary: Progress percentage not working as expected with foreman-installer
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Satellite
Classification: Red Hat
Component: Installer
Version: 6.7.0
Hardware: x86_64
OS: Linux
high
high
Target Milestone: 6.7.0
Assignee: Ewoud Kohl van Wijngaarden
QA Contact: Devendra Singh
URL:
Whiteboard:
: 1802005 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-12-09 13:52 UTC by Devendra Singh
Modified: 2020-04-14 13:28 UTC (History)
8 users (show)

Fixed In Version: kafo-4.0.1
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-04-14 13:27:49 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Foreman Issue Tracker 28827 Normal Closed Progress percentage not working as expected with foreman-installer 2020-07-10 11:22:47 UTC
Red Hat Product Errata RHSA-2020:1454 None None None 2020-04-14 13:28:03 UTC

Description Devendra Singh 2019-12-09 13:52:21 UTC
Description of problem:

There was no in-between processing percentage(It starts with "0" and after 4 to 5 minutes suddenly reached 100%, there is no in-between number 1% 2%....99%) displayed while we applying the particular deployment size.


Version-Release number of selected component (if applicable):
6.7.0

How reproducible:
always

Steps to Reproduce:
1. triggered "foreman-installer --tuning default" command on 6.7 setup
2. The installation progress bar started from 0 and after 4 to 5 minutes it suddenly reached 100, So here the in-between percentage was missing.


Actual results:
The processing percentage was not displayed. 

Expected results:
Processing percentage should be displayed

Additional info:

Comment 3 Eric Helms 2019-12-19 14:32:09 UTC
Can you attach an installer log so that we can see what steps were taking the longest and showing no progress?

Comment 5 sthirugn@redhat.com 2020-01-20 15:59:49 UTC
Can you check if this is still happening? I can see progress bar in satellite-cli-6.7.0-4.beta.el7sat.noarch:

# satellite-installer --tuning medium --disable-system-checks
Package versions are locked. Continuing with unlock.
Installing             Debug: Prefetching cli resources for foreman_confi [0%] [        ]

Comment 6 Devendra Singh 2020-01-20 16:34:16 UTC
(In reply to sthirugn@redhat.com from comment #5)
> Can you check if this is still happening? I can see progress bar in
> satellite-cli-6.7.0-4.beta.el7sat.noarch:
> 
> # satellite-installer --tuning medium --disable-system-checks
> Package versions are locked. Continuing with unlock.
> Installing             Debug: Prefetching cli resources for foreman_confi
> [0%] [        ]

Yes, it is still happening, 
the percentage value starts from 0% and after 1 to 2 minutes the progress reached 100%, but the in-between value like 1%, 5%, 50%, 65% 99% are missing.

how would I know the percentage of completion(1%, 5%, 7%....60%...99%) if it has only two value 0(beginning) and 100(ending)?

If you check the foreman-installer or satellite-installer in 6.6, 6.5 it works perfectly.

Comment 7 sthirugn@redhat.com 2020-01-20 16:57:03 UTC
Hello Devendra,
Yes, I see it moves from 0% to 100% quickly. I am not sure if this is because the installer is running quickly.

Ewoud, thoughts?

Comment 8 Ewoud Kohl van Wijngaarden 2020-01-20 17:19:14 UTC
The progress bar works by counting the amount of resources to monitor via MONITOR_RESOURCE. Then it looks at 'Starting to evaluate the resource' and Evaluated in [\d\.]+ seconds. I can see the MONITOR_RESOURCE lines in the log but not the evaluation which suggests it doesn't log those anymore. That means it can't update the progress. From the log it appears it wasn't an instant run so that can't explain it (Applied catalog in 126.32 seconds) but I don't see anything else.

https://github.com/theforeman/kafo/blob/master/lib/kafo/progress_bar.rb

The git changes to kafo don't suggest changes in this area, but it must be noted that in upstream this isn't really tested anymore. With Puppet 6 the hacks applied to Puppet no longer work and no progress bar is present. Downstream still uses Puppet 5 so there is still a progress bar present.

Comment 9 Ewoud Kohl van Wijngaarden 2020-01-21 15:45:16 UTC
To the person who's diving into this (which may very well be me), I'd make sure puppet evaltrace is enabled. Whether it's via a command line switch or a configuration option.

On a slightly related note, Puppet 6.6.0 implements the progress directly via evaltrace which means we can also implement this on Puppet 6. https://tickets.puppetlabs.com/browse/PUP-6465

Comment 10 Ewoud Kohl van Wijngaarden 2020-01-21 16:27:31 UTC
Created redmine issue https://projects.theforeman.org/issues/28827 from this bug

Comment 12 Bryan Kearney 2020-01-21 17:02:52 UTC
Upstream bug assigned to ekohlvan@redhat.com

Comment 13 Bryan Kearney 2020-01-21 17:02:53 UTC
Upstream bug assigned to ekohlvan@redhat.com

Comment 15 Bryan Kearney 2020-01-22 11:03:14 UTC
Moving this bug to POST for triage into Satellite 6 since the upstream issue https://projects.theforeman.org/issues/28827 has been resolved.

Comment 16 Zach Huntington-Meath 2020-02-13 14:04:46 UTC
*** Bug 1802005 has been marked as a duplicate of this bug. ***

Comment 17 Devendra Singh 2020-02-17 09:44:06 UTC
FailedQA.

Tested on 6.7 Snap12.

The Fixed version is "kafo-4.0.1" but updated version is "rubygem-kafo-4.0.0-1.el7sat.noarch"

Comment 21 Devendra Singh 2020-02-24 13:42:29 UTC
Verified successfully on 6.7 Snap13.

# satellite-installer --tuning default
Package versions are locked. Continuing with unlock.
Installing             Package[ca-certificates]                           [12%] [................                                                                                                                ]
Installing             Service[named]                                     [34%] [.............................................                                                                                   ]
Installing             Foreman_smartproxy                                 [97%] [.............................................................................................................................    
Installing             Done                                               [100%][................................................................................................................................]

Success!

# rpm -q rubygem-kafo
rubygem-kafo-4.0.1-1.el7sat.noarch

Comment 24 errata-xmlrpc 2020-04-14 13:27:49 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2020:1454


Note You need to log in before you can comment on or make changes to this bug.